/* 
This work is licensed by the Creative Commons
Attribution-NonCommercial-ShareAlike 1.0

Key License Terms:
Attribution. The licensor permits others to copy, distribute, display, and perform the work. In return, licensees must give the original author credit.

Noncommercial. The licensor permits others to copy, distribute, display, and perform the work. In return, licensees may not use the work for commercial purposes -- unless they get the licensor's permission.

Share Alike. The licensor permits others to distribute derivative works under a license identical to the one that governs the licensor's work.

http://creativecommons.org/licenses/by-nc-sa/1.0

Visit http://www.blozom.com for commercial licensing terms.  
Copyright 2003, Uzilla LLC
*/

var moreContent = '';

var blozomMapObj = new Object();

function blozomMap(mapLocale, folder) {
	//dump("Mapping \n");
	var tempDirObj, newDirPath;
	//dump("\n\nMapping " + folder + "\n");
	var myDirPath = folder;
	var myDir = new Dir(myDirPath);
	var myDirArray = myDir.readDir();
	//dump("Looping over " + myDirArray.length + " dir elements \n");
	for(i in myDirArray) {
		//dump("map loop at i " + i + " " + myDirArray[i].path + "\n");
		if(myDirArray[i]) {
		//dump("Looking at " + i + " at " + myDirArray[i].path + " of type " + myDirArray[i].isDir() + "\n");
		if(myDirArray[i].isDir()) {
			
			if(myDirArray[i].path.indexOf('2003') == -1) {
				//dump("Pubbing blog folder " + myDirArray[i].path + "\n");
				//dump("len is " + myDirArray[i].path.split("/").length + "\n");
				dump("Mapping regualr file " + myDirArray[i].path + "\n");
			
			}
			
			
			mapLocale[myDirArray[i].path] = new Object;
			if(myDirArray[i].path.indexOf('2003')) {
				mapLocale[myDirArray[i].path].blogFolder = true;
			}
			 //addDirectory(document.getElementById("blozom-tree-root"), myDirArray[i],i);
			blozomMap(mapLocale[myDirArray[i].path], myDirArray[i].path);
			
		}
		else {
			//dump("Mapping file " + myDirArray[i].path + "\n");
			if(myDirArray[i].isFile() || myDirArray.path.indexOf(".xml") == -1) {
				mapLocale[myDirArray[i].path] = new Object();	
					
				
			}
		}
	}
	}
 // dump("\nPopping recursion stack\n");
}


// Returns content for navigating among day's posts
function blogMap() {
	//for(i in blozomMapObj) dump("----" + i + "\n");
	var myContent = '';
	var archives = blozomMapObj[blozomDataPath + blozomFileSeparator +"2003"];
	//for(i in archives) dump("====" + i + "\n");
	// Loop over months 
	for(month in archives) {
		dump("Month is " + month + "\n");
		if(archives[month].length) {
		myContent += '<span class="month"> Month:' + listLast(month) ;
		for(day in archives[month]) {
			//if(archives[month][day].length) {
			dump("day is " + archives[month][day] + "\n");

			myContent+= ' <a href="' + blozomWebRoot + '">Day:' + listLast(day) + '</a>';
			//}
		}
		myContent +="</span>";
		}
	}
	//dump("\n\n >>>>content is " + myContent + "\n");
	return myContent;
}
	
// ANTIQUATED? Yes
function blozomPublish() {
	dump("Initing publish \n");
	
	blozomMap(blozomMapObj, blozomDataPath);
	moreContent += blogMap();
	//blozomInitPublish();
	dump("Publishing \n");
	blozomPublishFolder(blozomDataPath);
	
}





function blozomPublishFolder(folder) {
	var tempDirObj, newDirPath, blogRegex;
	dump("\n\nPubbing " + folder + "\n");
	var myDirPath = folder;
	var myDir = new Dir(myDirPath);
	var myDirArray = myDir.readDir();
	//dump("Looping over " + myDirArray.length + " dir elements \n");
	for(i in myDirArray) {
		//dump("publish loop at i " + i + " " + myDirArray[i].path + "\n");
		if(myDirArray[i]) {
		dump("Looking at " + i + " at " + myDirArray[i].path + " of type " + myDirArray[i].isDir() + "\n");
		if(myDirArray[i].isDir()) {
			dump("adding a directory\n");
			newDirPath = blozomPublishPathFromDataPath(myDirArray[i].path);
			
			tempDirObj = new Dir(newDirPath)
			if(!tempDirObj.exists()) {
				dump("Directory does not exist.");
				tempDirObj.create();
			}

			//blogRegex = new RegExp("\d{4}\\d{2}\\d{2}", "i");
			//dump(" regex match is " + blogRegex.test(newDirPath) + "\n");
			//dump("hack match is " + newDirPath.indexOf("2003") + " " + newDirPath.indexOf("\\01\\") + "\n");
			// TODO Year Regex
			if(newDirPath.indexOf("2003") > -1 && newDirPath.split(blozomFileSeparator).length  > 4 ) {
				blozomPublishFolderBlogStyle(myDirArray[i].path);
			} else {
			blozomPublishFolder(myDirArray[i].path);
			}
			 //addDirectory(document.getElementById("blozom-tree-root"), myDirArray[i],i);
		}
		else {
			dump("Pubbing file " + myDirArray[i].path + "\n");
			if(myDirArray[i].isFile()) {
				blozomPublishFile(myDirArray[i]);
			}
		}
	}
	}
  //dump("\nPopping recursion stack\n");
}


function blozomAggregateDay(dayFolder) {
	dump("Aggregating day content \n")
	var myContent = '';
	var contentObj;
	var myDateComponents = dayFolder.path.replace(blozomDataPath, "").split(blozomFileSeparator);
	var pubYear = myDateComponents[1];
	var pubMonth = myDateComponents[2];
	var pubDay =  myDateComponents[3];
	var tempDate;
	var dayFiles = dayFolder.readDir();
	//dump("%#%#%#%#%#%# Read directory in day aggregate of " + dayFolder.path + " and found " + dayFiles.length + "\n");
	for (k in dayFiles) {
		contentFile = dayFiles[k];
		//dump("considering day file " + contentFile.path + "\n");
		contentFile.open("r");
		tempContent = contentFile.read();
		dump("  " + contentFile.path  + " of " + tempContent.length+ " chars\n");
		contentFile.close();
		if(contentFile.path.indexOf(".xml") == -1) {	
			myContent += blozomItemHead;
			var contentObj= blozomMetaForPublish(contentFile.path.replace(".txt", ".xml"))

			myContent += "<a name='" + contentFile.path.replace(".xml","") + "'></a><h3>" + contentObj.title + "</h3>";
			
			myContent += tempContent;
			if(structCount(contentObj)){
			myContent +="<span style='float:right'>";
			myContent +="<a href=" + blozomWebRoot  + pubYear + "/" + pubMonth + "/" + pubDay + "/index" + blozomFileExtension + "#" + listLast(dayFiles[k].path).replace(".txt","") + "><small>|||</small></a></span>";		
			// Put in pub date
			//dump("pub date is " + contentObj["pubdate"] + "\n");
			myContent += "<span class='blogDateAndCategory'>";
			if(contentObj["pubdate"] != 'undefined' && contentObj["pubdate"] != 'Invalid Date'  ) {
				
				if(contentObj["pubdate"].indexOf("2003") == -1) {
					//dump("Millisecond date \n");
					tempDate = new Date(contentObj["pubdate"]);
					//tempDate.setTime();
				
				 myContent += "<br/>Posted at " + tempDate.getHours() + ":" + tempDate.getMinutes();
				} else {
					//dump("Good, GMT date \n");
					tempDate = new Date(contentObj["pubdate"]);
					//tempDate = Date.parse();
				 myContent += "<br/>Posted at " + tempDate.getHours() + ":" + tempDate.getMinutes();
				}
			}

			
			var numCategories = 0;
		
				for(i in contentObj.categories) {
					numCategories++;
					if(numCategories == 1) myContent +=  ", Published in: ";
					myContent+= " " + i;
				} 
			}
			myContent+= "</span>";
			myContent  += blozomItemTail ;
		}
	}
	return myContent;
}

function structCount(obj) {
	var counter = 0;
	for(i in obj) counter++;
	return counter;
}

function blozomMetaForPublish(filePath) {
	var contentObj = new Object;
	dump("   Extracting metadata for " + filePath + "\n");
	var tempFile = new File(filePath);
	tempFile.open("r");
	var xmlContent = tempFile.read();
	//dump("XML is " + xmlContent + "\n");
	var metaData = new DOMParser().parseFromString(xmlContent, "text/xml");
	var title = metaData.childNodes.item(0).childNodes.item(0).childNodes.item(0).childNodes.item(0).data;
	contentObj.title = title;
	var item = metaData.childNodes.item(0).childNodes.item(0)
	//dump("item value is " + item + " " + item.value + " " + item.nodeValue + "\n");
	//dump("val is " + item.value + "\n");
	//dump("nodenamed item is " + item.nodeName + "\n");
	//dump("nodeval item is " + item.nodeValue+ "\n");
	
	//for(i in item) dump(i + " " + item[i] + "\n");
	//dump("Found meta data " + metaData + " \n");
	//dump(" childs " + metaData.childNodes.length + "\n");

	/*var categories = metaData.getElementsByTagName("category");
	dump(" item() returns " + categories.item(1) + "\n");
	*/
	//dump("&& Looking for categories at " + item.nodeName + " " + item.childNodes.length + " childs \n");
	contentObj.categories = new Object();
	
	if(item.childNodes.length > 0) contentString += "Published in: ";
	try {
	for(var i=0;i< item.childNodes.length;i++) {
		//dump(item.childNodes.item(i).nodeName + "\n");
		if(item.childNodes.item(i).nodeName == "category") {
			contentObj.categories[ item.childNodes.item(i).childNodes.item(0).nodeValue] = 1;
		}
		if(item.childNodes.item(i).nodeName == "pubdate") {
			contentObj["pubdate"] = item.childNodes.item(i).childNodes.item(0).nodeValue;
		}
	} 
	} catch(err) {
	dump(err + "error trapped in blogpost footer\n");
	}
	return contentObj;
}

function blozomPublishMonthlyArchives() {
	//var breadCrumbString = buildBreadCrumb(myFolder)
 	var contentFile, myContent, tempContent;
	var dayFolder, dayFiles;
	var tempMonth;
	var monthFolder = new Dir(blozomDataPath + blozomFileSeparator + "2003");
	var dirMonth = monthFolder.readDir();
	dump("{Pubbing Monthly archives, Looping over " + myDirArray.length + " dir elements \n");
	
	for(i in dirMonth) {
		tempMonth = getMonthFromPath(dirMonth[i].path);
		dump("  Looping over a month's entries " + tempMonth + " at " + dirMonth[i].path + " \n");
		if(dirMonth[i].isDir()) {
			dayFolder = dirMonth[i].readDir();
			for(j in dayFolder) {
				
				if(dayFolder[j].isDir()) {
				
					dump("Looking at " + dayFolder[j].path + "\n");
				
					if(dayFolder[j].isDir()) {
						/*myContent += blozomAggregateDay( dayFolder[j] ) + myContent;
						blozomPublishDayArchive(dayFolder[j], myContent);
						*/
						tempContent = blozomAggregateDay( dayFolder[j] );
						myContent += tempContent;
						blozomPublishDayArchive(dayFolder[j], tempContent);
					}
				}
			}
		//var renderPath = blozomPublishPathFromDataPath(); 
		var renderPath = blozomPublishPath + blozomFileSeparator + curYear + blozomFileSeparator + tempMonth + blozomFileSeparator + "index" + blozomFileExtension;
		dump("Rendering blog monthly archives page to " + renderPath  + " From month of " + tempMonth + "\n");
		//dump("Content is " + header + myContent + moreContent +  footer + "\n\n");
		var myFile = new File(renderPath);
		//blozomInsurePath(renderPath);
		if(!myFile.exists()) myFile.create();
		 myFile.open('w',744);
		 myFile.write(blozomHeaderBlob  + myContent + moreContent +  blozomFooterBlob );
		dump("wrote monthly archives to " + renderPath + "\n");
		 myFile.close();
		 myContent = '';
		}
	} 
}

function blozomPublishDayArchive(dayFolder, myContent){
	dump(">>>> Pubbing day archive for " + dayFolder.path + " with content " + myContent.length + "\n")
	var renderPath = blozomPublishPathFromDataPath(dayFolder.path) + "\\index" + blozomFileExtension; 
			//dump("writing day archives to " + renderPath + "\n");
	var myFile = new File(renderPath);
	
	//blozomInsurePath(renderPath);
	if(!myFile.exists()) {
		dump(" Creating day archive \n");
		blozomInsurePath(renderPath);
		myFile.create();
	}
		 myFile.open('w',744);
		 myFile.write(blozomHeaderBlob  + myContent + moreContent +  blozomFooterBlob );
		 //dump(" wrote day archives to " + renderPath + "\n");
		 myFile.close();

}



// Monthly Archives
// TODO subroutine generation of day html
// use in monthly, daily, and homepage render
function blozomPublishFolderBlogStyle(myFolder) {
	var breadCrumbString = buildBreadCrumb(myFolder)
	dump("\n\npublishing folder blog style " + myFolder + "\n");
 	var contentFile, myContent, tempContent;
	var myDirPath = myFolder;
	var myDir = new Dir(myDirPath);
	var myDirArray = myDir.readDir();
	//dump("Looping over " + myDirArray.length + " dir elements \n");
	// TODO: change content file to dayFolder
	for(i in myDirArray) {
		dump("Looping over a day's entries at " + myDirArray[i].path + "\n");
		
		if(myDirArray[i].isDir()) {
			myContent += blozomAggregateDay( myDirArray[i] ) + myContent;
		}
	}	
	var renderPath = blozomPublishPathFromDataPath(myFolder); 
	renderPath = renderPath + blozomFileSeparator + "index" + blozomFileExtension;
	dump("[[[RENDER]]] Rendering blog page to " + renderPath + "\n");
	//dump("Content is \n" + myContent + "\n" + moreContent + "\n\n");
	var myFile = new File(renderPath);
	 myFile.open('w',744);
	 myFile.write(blozomHeaderBlob + breadCrumbString + "<br/>" + myContent + moreContent +  blozomFooterBlob );
	 myFile.close();
	
}

function buildBreadCrumb(strPath) {
	strPath = strPath.replace(blozomDataPath, "");
	
	var arPath = strPath.split("\\");
	var returnString = '<span class="dateHead">';
	var curWebPath = blozomWebRoot;
	for(var i=0;i<arPath.length-1;i++) {
		if(arPath[i].length) {
			//dump("adding " + arPath[i] + " breadcrumb \n");
			curWebPath += arPath[i] + "/";
			returnString += '<a href="' + curWebPath + '">';
			returnString += arPath[i];
			returnString += '</a>' + " // ";
		}
	}
	if(arPath.length > 0) {
	var filePath = arPath[arPath.length-1].replace(".txt", blozomFileExtension);
	//returnString = '<a href="' + curWebPath + "/" + filePath  + '">';
	returnString += filePath;
	//returnString += '</a>' + " // ";
	}
	return returnString + "</span>";
}
function blozomPublishFile(contentFile) {
	var breadCrumbText = buildBreadCrumb(contentFile.path);
	//dump("in publish \n");
	contentFile.close();
	contentFile.open("r");
	var content = contentFile.read();
	//dump("read content file \n");
	var renderPath = blozomPublishPathFromDataPath(contentFile.path);
	renderPath = renderPath.replace(".txt", blozomFileExtension);
	dump("Publishing to path " + renderPath + "\n");
	var myFile = new File(renderPath);
	blozomInsurePath(renderPath);
	if(!myFile.exists()) {
		dump("No file exists, creating \n");
		myFile.create();
	}
	//dump("Opening to write\n");
	 myFile.open('w',744);
	 myFile.write(blozomHeaderBlob + breadCrumbText +  "<br/>" + content + moreContent +  blozomFooterBlob );
	 myFile.close();
}

function publishMonthlyArchives() {
	for(var i=1; i<xfmlRoot.childNodes.length;i++) {
		dump("pubbing item \n");
	} 
}

// TODO Port the maintenance of publishing history
// to use of map.xml
function blozomPublishHomePage() {
	dump("Publishing home page \n");
	var arPath;
	var myContent = '';
	var tempNode;

	var tempFolder;
	var tempPath;
	var tempDay;
	var tempMonth;
	var tempYear;
	var daysPubbed = new Object;
	var publishPath = blozomPublishPath + '\\index' + blozomFileExtension;
	dump("Working file " + publishPath + "\n")

	//                      blozom node        blogs node
	root = xfmlRoot.childNodes.item(0).childNodes.item(1);
	dump("Publishing homepage " + root.nodeName + " " + root.childNodes.item(0).nodeName + "\n");
	var stopPost = root.childNodes.length - 10;
	if(stopPost < 0) stopPost = 0;
	
	for(var i = root.childNodes.length - 1; i >= stopPost; i=i-1) {
		//dump(" item node is " + root.childNodes.item(i).nodeName + "\n");
		tempNode = root.childNodes.item(i);
		tempPath = tempNode.getElementsByTagName("path").item(0).childNodes.item(0).nodeValue;
		
		// TODO Bundle-this
		tempPath = tempPath.replace(blozomDataPath, "");
		//dump("Temp Path is " + tempPath + "\n");
		arPath = tempPath.split("\\");
		tempYear = arPath[1];
		tempMonth = arPath[2];
		tempDay = arPath[3];
		if(!daysPubbed[tempYear + tempMonth + tempDay]) {
		daysPubbed [tempYear + tempMonth + tempDay] = true;
		myContent+= "<h2 class='dateHead'>" + tempDay + " - " + tempMonth + " - " + tempYear + "</h2>";
		dump("temp day is " + tempDay + "," + tempMonth + " " + tempYear +  "\n");
		//dump("Looking for " + blozomDataPath + " path " + blozomFileSeparator + " sep " + tempYear +  " year" + blozomFileSeparator +  " month " + tempMonth + " sep " +  blozomFileSeparator + " day " + tempDay + "\n");
		var tempFolder = new Dir(blozomDataPath + blozomFileSeparator + tempYear + blozomFileSeparator + tempMonth + blozomFileSeparator + tempDay);
		//dump("Looking at " + tempFolder.path + "\n");
		// End Bundle-this
		try {
		myContent += blozomAggregateDay(tempFolder);
		} catch(e) {
			dump(">--- ERROR ---<\n PublishHomePage \n");
		}
		//for(j in tempNode) dump(j + " " + tempNode[j] + "\n");
		//blozomAggregateDay(
		}
	}

	var publishFile = new File(publishPath);
	dump("Writing " + publishFile.path + "\n");
	if(!publishFile.exists()) {
		publishFile.create();
		dump("Created publish file \n");
	}
	publishFile.open("w");
	publishFile.write(blozomHeaderBlob +  myContent  +  blozomFooterBlob);
	publishFile.close();
}