/* 
This work is licensed by the Creative Commons
Attribution-NonCommercial-ShareAlike 1.0

Key License Terms:
Attribution. The licensor permits others to copy, distribute, display, and perform the work. In return, licensees must give the original author credit.

Noncommercial. The licensor permits others to copy, distribute, display, and perform the work. In return, licensees may not use the work for commercial purposes -- unless they get the licensor's permission.

Share Alike. The licensor permits others to distribute derivative works under a license identical to the one that governs the licensor's work.

http://creativecommons.org/licenses/by-nc-sa/1.0

Visit http://www.blozom.com for commercial licensing terms.  
Copyright 2003, Uzilla LLC
*/

// put listLast, etc here

function dumpXML(xml, len) {
	 var output = new DOMParser().parseFromString(blozomCategoryXML, "text/xml");
	dump("\n\nXML CONTENT\n" + output + "\n\n");
}

function xmlEscape(myText) {
	myText = replaceAll(myText, "<", "&lt;");
	myText = replaceAll(myText, ">", "&gt;");
	myText = replaceAll(myText, "&", "&amp;");
	dump("returning xml escaped " + myText + "\n");
	return myText;	
}

function xmlUnescape(myXML) {
	myText = replaceAll(myXML, "&lt;", "<");
	myText = replaceAll(myXML, "&gt;", ">");
	myText = replaceAll(myXML, "&amp;", "&");
	dump("returning xml escaped " + myXML + "\n");
	return myXML;
}

function replaceAll(myString, mySubString, myNewString) {
	if(myString != 'undefined') {
		dump("Replacing in " + myString + " this " + mySubString + " with " + myNewString + "\n");
		if(myString.length > 0) {
			while(myString.indexOf(mySubString) > -1) {
				//dump("repped " + myString + "\n");
				myString = myString.replace(mySubString, myNewString);
		}
		return myString;
	} else {
		return '';
	}
	}
}

function listLast(list) {
	var arList = list.split(blozomFileSeparator);
	return arList[arList.length - 1];
}

function blozomPublishPathFromDataPath(path) {
	return path.replace(blozomDataPath, blozomPublishPath);
}

function listLen(mylist, separator) {
	var arList = mylist.split(separator);
	return arList.length;
}


function getMonthFromPath(strPath) {
	//dump("Finding month in " + strPath + "\n");
	strPath = strPath.replace(blozomDataPath,"");
	var arPath = strPath.split(blozomFileSeparator);
	//for(i in arPath) dump("getting month " + i + " " + arPath[i] + "\n");
	return arPath[2];

}